﻿SLASH_INTERRUPTMANAGER1 = '/im'

function InterruptManager_OnLoad()
    InterruptManager:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
    InterruptManager:RegisterEvent("CHAT_MSG_ADDON")
    InterruptManager:RegisterEvent("UNIT_SPELLCAST_CHANNEL_START")
    InterruptManager:RegisterEvent("UNIT_SPELLCAST_START")
    SendAddonMessage("InterruptM","Remind","RAID")
end

local c = CreateFrame("MessageFrame","InterruptManagerText")
c:SetWidth(300)
c:SetHeight(30)
c:SetPoint("CENTER", UIParent, "CENTER", 0, 80)
c:SetFont("Fonts\\FRIZQT__.TTF", 25)
c:SetFadeDuration(1)
c:SetTimeVisible(2)

interrupters = {IM1,IM2,IM3,IM4,IM5}
local version = 1.05
PUGMode = 0
local announce = 1
local focusMode = "target"
local soloMode = 0
local registeredUsers = {}
local interruptSpells = {96231, 80964, 80965, 78675, 47528, 47476, 2139, 1766, 51680, 34490, 57994, 19647, 26090, 6552, 15487, 72}

function InterruptManager_OnEvent(self, event, ...)
    if event == "COMBAT_LOG_EVENT_UNFILTERED" then
        local timestamp, type, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags = select(1, ...)
        if type == "UNIT_DIED" then
            if tContains(interrupters,destName) then
                tremove(interrupters,destName)
            end
        end
        if (type == "SPELL_CAST_SUCCESS") then
            local spellID, spellName, spellSchool = select(9, ...)
            if tContains(interruptSpells, spellID) then
                if sourceName == GetUnitName("player") then
                    if announce == 1 then
                        SendChatMessage("Used "..spellName)
                    end
                end
                if tContains(interrupters, sourceName) then
                    if #interrupters == 1 then
                        interrupters[1] = sourceName
                    end
                    if #interrupters == 2 then
                        if interrupters[1] == sourceName then
                            interrupters[1] = interrupters[2]
                        end
                        interrupters[2] = sourceName
                    end
                    if #interrupters == 3 then
                        if interrupters[1] == sourceName then
                            interrupters[1] = interrupters[2]
                            interrupters[2] = interrupters[3]
                            elseif
                            interrupters[2] == sourceName then
                            interrupters[2] = interrupters[3]
                        end
                        interrupters[3] = sourceName
                    end
                    if #interrupters == 4 then
                        if interrupters[1] == sourceName then
                            interrupters[1] = interrupters[2]
                            interrupters[2] = interrupters[3]
                            interrupters[3] = interrupters[4]
                            elseif interrupters[2] == sourceName then
                            interrupters[2] = interrupters[3]
                            interrupters[3] = interrupters[4]
                            elseif interrupters[3] == sourceName then
                            interrupters[3] = interrupters[4]
                        end
                        interrupters[4] = sourceName
                    end
                    if #interrupters == 5 then
                        if interrupters[1] == sourceName then
                            interrupters[1] = interrupters[2]
                            interrupters[2] = interrupters[3]
                            interrupters[3] = interrupters[4]
                            interrupters[4] = interrupters[5]
                            elseif interrupters[2] == sourceName then
                            interrupters[2] = interrupters[3]
                            interrupters[3] = interrupters[4]
                            interrupters[4] = interrupters[5]
                            elseif interrupters[3] == sourceName then
                            interrupters[3] = interrupters[4]
                            interrupters[4] = interrupters[5]
                            elseif interrupters[4] == sourceName then
                            interrupters[4] = interrupters[5]
                        end
                        interrupters[5] = sourceName
                    end
                    if PUGMode == 0 then
                        if GetNumRaidMembers() > 0 then
                            SendChatMessage("Interrupting next: "..interrupters[1],"RAID")
                            elseif GetNumPartyMembers() > 0 then
                            SendChatMessage("Interrupting next: "..interrupters[1],"PARTY")
                        end
                    end
                    if interrupters[1] == UnitName("player") then
                        InterruptManagerText:AddMessage("You are interrupting next!",0,1,0)
                        PlaySoundFile("Sound\\Interface\\PVPFlagCapturedHordeMono.wav")
                    end
                end
            end
        end
        elseif event == "CHAT_MSG_ADDON" then
        local prefix, msg,_,sender = select(1,...)
        if msg == "Remind" and sender ~= UnitName("player") then
            IMUpdateInterrupters()
        end
        if prefix == "InterruptManager" then
            if sender ~= UnitName("target") and not tContains(registeredUsers,sender) and tContains(interrupters,sender) then
                print("InterruptManager: Received addon response from "..sender)
                tinsert(registeredUsers,sender)
                for i=1,#interrupters do
                    if #interrupters == #registeredUsers and i == #interrupters then
                        ChatFrame1:AddMessage("All interrupters have InterruptManager enabled.",0,1,0)
                        PugMode = 1
                        else
                        ChatFrame1:AddMessage("Warning: Not all interrupters have InterruptManager enabled. Going PUG mode.",1,0.1,0)
                        PUGMode = 0
                        break
                    end
                end
            end
        end
        if string.find(prefix,"IM") and msg then
            SendAddonMessage("InterruptManager",version,"GUILD")
        end
        if prefix == "IM1" and msg and msg ~= "" then
            interrupters[1] = msg
            elseif prefix == "IM2" and msg and msg ~= "" then
            interrupters[2] = msg
            elseif prefix == "IM3" and msg and msg ~= "" then
            interrupters[3] = msg
            elseif prefix == "IM4" and msg and msg ~= "" then
            interrupters[4] = msg
            elseif prefix == "IM5" and msg and msg ~= "" then
            interrupters[5] = msg
        end
        elseif event == "UNIT_SPELLCAST_START" or event == "UNIT_SPELLCAST_CHANNEL_START" then
        local caster,_,_,_,spellID = select(1,...)
        wipe(registeredUsers)
        if caster == focusMode and (interrupters[1] == UnitName("player") or soloMode == 1) then
            local _, _, _, _, _, _, _, _, i = UnitCastingInfo(focusMode)
                if not i then
                PlaySoundFile("Sound\\Interface\\PVPFlagTakenMono.wav")
                InterruptManagerText:AddMessage("Interrupt!",0,0,1)
            end
        end
    end
end

function SlashCmdList.INTERRUPTMANAGER(msg, editbox)
    IMConfigFrame:Show()
end

function IMAnnounceToggle()
    if announce == 1 then
        announce = 0
        IMConfigAnnounceToggleButton:SetText("Enable Announce")
        ChatFrame1:AddMessage("InterruptManager: Announce is now disabled.",1,0.5,0)
    else
        announce = 1
        IMConfigAnnounceToggleButton:SetText("Disable Announce")
        ChatFrame1:AddMessage("InterruptManager: Announce is now enabled.",1,0.5,0)
    end
end

function IMFocusModeToggle()
    if focusMode == "target" then
        focusMode = "focus"
        IMConfigFocusToggleButton:SetText("Disable Focus Mode")
        ChatFrame1:AddMessage("InterruptManager: Focus mode is now enabled. Will now only warn when your focus is casting a spell.",1,0.5,0)
        else
        focusMode = "target"
        IMConfigFocusToggleButton:SetText("Enable Focus Mode")
        ChatFrame1:AddMessage("InterruptManager: Focus mode is now disabled.",1,0.5,0)
    end
end

function IMSoloModeToggle()
    if soloMode == 0 then
        soloMode = 1
        IMConfigSoloToggleButton:SetText("Disable Solo Mode")
        ChatFrame1:AddMessage("InterruptManager: Solo mode is now enabled. Will now warn if a spell is being cast by your target/focus regardless of your position in the queue.",1,0.5,0)
        else
        soloMode = 0
        IMConfigSoloToggleButton:SetText("Enable Solo Mode")
        ChatFrame1:AddMessage("InterruptManager: Solo mode is now disabled.",1,0.5,0)
    end
end

function IMUpdateInterrupters()
    wipe(interrupters)
    for i=1,5 do
        if getglobal("IMConfigEditbox"..i):GetText() ~= "" and not strfind(getglobal("IMConfigEditbox"..i):GetText()," interrupter") then
            interrupters[i] = getglobal("IMConfigEditbox"..i):GetText()
        end
    end
    SendAddonMessage("IM1",interrupters[1],"RAID")
    SendAddonMessage("IM2",interrupters[2],"RAID")
    SendAddonMessage("IM3",interrupters[3],"RAID")
    SendAddonMessage("IM4",interrupters[4],"RAID")
    SendAddonMessage("IM5",interrupters[5],"RAID")
end